; ******************************************************************
; * Hektarzaehler
; * File : main.asm + function.asm
; * 
; * Programm Flaechenanzeige auf LCD - Anzeige (1x16, 8+8)
; * Datum : 11.05.1992
; * fuer 8032 EPC aus ELEKTOR 2/91 mit 8031
; * String-Ausgabe gegenueber ha535.asm geaendert
; * Neu: MC AT89C51RC2 bzw. AT89S52
; *******************************************************************
; Funktion --> OK
;
; Funktionen:
; ADD_BIN			Addition zweier Binaerzhlen
; CONBCD            Umwandlung in 5 Byte BCD-Zahl FF FF FF FF FF -> 4294967295
;	LOE1            loeschen
;	TRA0            Parameter laden
;	TRA1
;	TRA_BIN
; CONBIN 			Umrechnung BCD in Binaerzahl  9999 -> 27 0F
;	LOE0     	    loeschen
;	ADDA0       	<R0> + <A> --> <R0>
;   BIN10       	BIN*10 --> BIN
; UPM_D				Faktor Flaeche (Umfang * Breite * 1/0.75/0.5/0.25)
;					und durch 100 dividieren
; 	M16P16          Faktor U * Faktor B, 16*16 Multiplikation ohne Vorzeichen
;		M16P8		16*8 Multiplikation ohne Vorzeichen
;	CONBCD          umwandeln in BCD-Zahl
;	DIV_BCD         Divisionsprogramm (Faktor / 100)
;		SHIFT
;		SUBB_BCD    Subtraktion Rest-Divisor
;		ZEHNER_CPL  Zehner-Komplement des Rest bilden
;	CONBIN          umwandel in Binaer
;		LOE0        loeschen
;		ADDA0       <R0> + <A> --> <R0>
;       BIN10       BIN*10 --> BIN
; LCD_SENDSTRING
;	OUT_CHAR_LCD
;	LCD_ADR8
; LCD_CLEAR
; LCD_ADR1
; LCD_ADR8
; OUT_LCD 
;	WAIT_LCD
;	OUT_BYTE_LCD    Ausgabe LCD 2 Byte ASCII
;	OUT_CHAR_LCD
; OUT_WERT_LCD
;	OUT_CHAR_LCD
; OUT_BYTE_LCD
;	HEX_ASCII		Wandlung 00H-09H in 0 - 9
;	OUT_CHAR_LCD
; TASTATUR			Tasten Dekodierung
;	ENTPRELL
; TASTEN_EINGABE 	Eingabe Umfang und Breite
;	Tastatur
;   OUT_CHAR_LCD
;	WAIT_LCD
; 	WAIT
; Time			 Verzoegerungszeit 2 Sekunden
; WAIT_LCD       Wartezeit LCD = 5ms
; WAIT			 Verzoegerungszeit 0.5ms
;
; Deklaration der LCD - Parameter
;
; $INCLUDE (function.a51)
;LCD_ADR      EQU  0F800H      ; Basisadresse LCD   FC00 ??
			     ; Basisadresse : Daten in das Befehlsregister
			     ;                schreiben
			     ; Basisadresse +2: Inhalt des Befehlsregister
			     ;                  lesen
			     ; Basisadresse +1: Daten in das Datenregister
			     ;                  schreiben
			     ; Basisadresse +3: Inhalt des Datenregister
			     ;                  lesen
;LCD_INI1     EQU  01H        ; Clear Display
;LCD_INI2     EQU  02H        ; Cursor Home
;LCD_INI3     EQU  06H        ; Entry Mode Set  06
;LCD_INI4     EQU  0FH        ; Display On, Cursor blink
;LCD_INI5     EQU  14H        ; Cursor/Display Shift  14
;LCD_INI6     EQU  38H        ; Funktion Set
;ADD1         EQU  80H        ; Cursoradresse Zeichen 0-7
;ADD2         EQU  0C0H        ; Cursoradresse Zeichen 8-15
;
;** Ende LCD - Parameter
;********************************************************************
;** Deklaration der Flaechenberechnung -- Parameter
;
;TMOD_CLR0     EQU  0F1H       ; Timer 0
;TMOD_SET0     EQU  01H       ; Timer 0
;TIMER_LOW     EQU  TL0
;TIMER_HIGH    EQU  TH1
;TIMER_RUN     EQU  TR0
;TIMER_ENA     EQU  ET0
;TIMER_PRIO    EQU  PT0
;MS10_HIGH     EQU  3CH            ; fuer 50 mS Interrupt
;MS10_LOW      EQU  0B0H
EIN           EQU  01H
AUS           EQU  00H
; BCD und Binaer Rechenprogramme
; aus FILE : BINBCD.asm
; Datum : 04.05.1991
;
; Parameter Multiplikations-Programm :
; (R0)   MSB Multiplikand
; (R0+1) LSB Multiplikand
; (R1)   LSB Multiplikator
; (R1+1) MSB Multiplikator
;
; Speicherbelegung :
; ANF +  0  Ergebnis       MSB
; ANF +  1  Ergebnis
; ANF +  2  Ergebnis
; ANF +  3  Ergebnis       LSB
; ANF +  4  Zwischenspeicher
; ANF +  5  Zwischenspeicher
; ANF +  6  Multiplikand  (MSB)
; ANF +  7  Multiplikand  (LSB)
; ANF +  8  Multiplikator (MSB)
; ANF +  9  Multiplikator (LSB)
; ANF + 10  Adresse       (R0)
; ANF + 11  Adresse       (R1)
; ANF + 12  Vorzeichenmaske
;

;ANF    EQU  70H

; Parameter Konvertierung CONBCD BIN --> BCD (FF FF FF FF --> 4294967295)
;BINLSB_BCD   EQU  43H            ; BIN Wort LSB
;BINMSB_BCD   EQU  40H            ; BIN Wort MSB
;ZWSLSB_BCD   EQU  3FH            ; Zwischenspeicher LSB
;BCDLSB_BCD   EQU  29H            ; BCD Wort LSB
;BCDMSB_BCD   EQU  25H            ; BCD Wort MSB
;ZBIT_BCD     EQU  20H            ; Bitzaehler
;ZBYBCD_BCD   EQU  05H            ; BCD Wortzaehler
;ZBYBIN_BCD   EQU  04H            ; BIN Wortzaehler
; Parameter Konvertierung CON BIN BCD --> BIN (9999 -> 27 0F)
;BINLSB_BIN   EQU  46H            ; BIN Wort LSB
;BINMSB_BIN   EQU  45H            ; BIN Wort MSB
;ZWSLSB_BIN   EQU  44H            ; Zwischenspeicher LSB
;BCDLSB_BIN   EQU  31H            ; BCD Wort LSB
;BCDMSB_BIN   EQU  30H            ; BCD Wort MSB
;ZBYBCD_BIN   EQU  02H            ; BCD Wortzaehler
;ZBYBIN_BIN   EQU  02H            ; BIN Wortzaehler

;** Ende Parameter Flaechenberechnung
;****************************************************************
; Tastendekodierung aus dem Buch:
; MC-Tools 2
; Die 8051-Mikrocontroller-Familie Einfuehrung in die Software
; Tastenprogramm TASTATUR_1 Seite 88 - 90
;** Parameter Tastenabfrage
; aus FILE : TASTE12.asm
; Datum : 10.05.19991
; Modus 0: TASTATUR_MODUS vor Unterprogrammaufruf geloescht
;          erst wenn Taste aktiv wird, Rueckkehr zum Hauptprogramm
; MODUS 1: TASTATUR_MODUS vor Unterprogrammaufruf gesetzt,
;          Tastenfeld wird einmal abgefragt.
;          Bei Rueckkehr zum Hauptprogramm gibt Carry an,
;          ob eine Taste betaetigt wurde.
;          CARRY = 0: keine Taste erkannt
;          CARRY = 1: Taste erkannt; Nummer der Taste steht in
;                     TASTEN_NUMMER

;TASTEN_PORT     EQU P1             ; benuetzter PORT
;P_ANZ           EQU  03H           ; Anzahl Portleitungen
;TASTATUR_MODUS  BIT  [0]          ; Steuerbit fuer Modus (20.0)
;EINGAENGE       EQU  00010111B     ; Maske fuer Tastaturport:
			     ; Tastaturpins = 1
			     ; unbenuetzte Portpins:
			     ; Eingaenge : 1
			     ; Ausgaenge : 0
;TASTEN_NUMMER   EQU  01H          ; Register 1
;SPALTEN_ZAEHLER EQU  02H          ;          2
;ZEILEN_ZAEHLER  EQU  03H          ;          3
;AUSGABE_MASKE   EQU  04H          ;          4
;EINLESE_MASKE   EQU  05H          ;          5

;ZAHLEN          EQU    00H
;FERTIG          EQU    03H
;LOESCHEN        EQU    05H

;HALB_BYTE       EQU    00H ; Merker Halbbyte Faktor U-B
;FLAN_POSI       EQU    01H ; Merker Positive Flanke

; **************************************************************
; * Speicher :
; *      10        ; Faktor U LSB
; *      11        ; Faktor U MSB
; *      12        ; Faktor B LSB 1
; *      13        ; Faktor B MSB 1
; *      14        ; Faktor 1/1 U*B LSB
; *      15        ; Faktor 1/1 U*B MSB
; *      16        ; Faktor 3/4 U*B LSB
; *      17        ; Faktor 3/4 U*B MSB
; *      18        ;
; *      19        ;
; *      1A        ; Faktor 1/4 U*B LSB
; *      1B        ; Faktor 1/4 U*B MSB
; *      1C        ; Faktor 1/2 U*B LSB
; *      1D        ; Faktor 1/2 U*B LSB
; *      25        ; Ergebnis Flaeche BCD MSB
; *      26        ;
; *      27        ;
; *      28        ;
; *      29        ; Ergebnis Flaeche BCD LSB
; *
; *      30        ; Faktor MSB
; *      31        ; Faktor LSB
; *      32        ; Merker Faktor Halbbyte
; *
; *      3F        ; Zwischenspeicher Konvertierung BIN --> BCD
; *      40        ; Konvertierung BIN --> BCD MSB
; *      41        ;
; *      42        ;
; *      43        ; Konvertierung BIN --> BCD LSB
; *      44        ; Zwischenspeicher Konvertierung BCD --> BIN
; *      45        ; Konvertierung BCD --> BIN MSB
; *      46        ; Konvertierung BCD --> BIN LSB
; *
; *      50        ; Verzoegerungszeit LSB
; *      51        ; Verzoegerungszeit
; *      52        ; Verzoegerungszeit MSB
; *
; *      55        ; Merker Impulse > 255
; *      56        ; Merker Impuls positive Flanke
; *      57        ; Zaehler Timer-Zeit
; *      58        ; Merker Taste Loeschen
; *
; *      60        ; Multiplikand LSB
; *      61        ; Multiplikand MSB
; *      62        ; Multiplikator LSB , Faktor U*B
; *      63        ; Multiplikator MSB , Faktor U*B
; *   BCD-Division  3 Byte / 3 Byte
; *      64        ; Divident LSB
; *      65        ;
; *      66        ; Divident MSB
; *      67        ; Divisor LSB  = 00
; *      68        ;              = 01
; *      69        ; Divisor MSB  = 00 --> 100
; *      6A        ; Ergebnis Quotient LSB
; *      6B        ;
; *      6C        ; Ergebnis Quotient MSB
; *      6D        ; Rest LSB
; *      6E        ;
; *      6F        ; Rest MSB
; *   BIN-Multiplikation 16*16
; *      70        ; Ergebnis MSB
; *      71        ;
; *      72        ;
; *      73        ; Ergebnis LSB
; *      74        ; Zwischenspeicher
; *      75        ; Zwischenspeicher
; *      76        ; Multiplikand MSB
; *      77        ; Multiplikand LSB
; *      78        ; Multiplikator MSB
; *      79        ; Multiplikator LSB

	 ORG  0000H
	 LJMP LCDINIT

	 ORG  000BH
	 RETI                     ; TIMERINTERRUPT

	 ORG  0100H

; START
; LCD-Anzeige Initialisieren
LCDINIT: 
   CLR P1.0
   MOV  DPTR,#LCD_ADR
	 MOV  A,#38H
	 MOVX @DPTR,A
	 LCALL WAIT_LCD      ; Wartezeit = 5ms
	 MOV  A,#38H
	 MOVX @DPTR,A
	 LCALL WAIT_LCD
	 MOV  A,#38H
	 MOVX @DPTR,A
	 LCALL WAIT_LCD
	 MOV  A,#0CH
	 MOVX @DPTR,A
	 LCALL WAIT_LCD
	 MOV  A,#01H
	 MOVX @DPTR,A
	 LCALL WAIT_LCD
	 MOV  A,#02H
	 MOVX @DPTR,A
	 LCALL WAIT_LCD
; Initialisierung LCD Ende
; Ausgabe Name und Software-Version (ha-Zaehler 1.1)
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING1
	 LCALL LCD_SENDSTRING
; Wartezeit
	 LCALL TIME              ; Wartezeit 2 Sekunden
	 CLR   P1.5
	 CLR   P1.6
	 CLR   P1.7
     CLR  P1.0
; Anzeige loeschen
FAK_U:   LCALL LCD_CLEAR
; Ausgabe LCD : Faktor U 00.00 m
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING2
	 LCALL LCD_SENDSTRING
; Eingabe Faktor U (Umfang)
	 LCALL TASTEN_EINGABE     ; Ausgabe BCD-Zahl,
				                    ; 30 <-- MSB, 31 <-- LSB
	 LCALL CONBIN             ; Faktor U --> Binaerzahl
	 MOV   (61H),(46H)        ; Faktor U LSB
	 MOV   (60H),(45H)        ; Faktor U MSB
	 LCALL LCD_CLEAR
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING2
	 LCALL LCD_SENDSTRING
	 LCALL OUT_WERT_LCD       ; Ausgabe Faktor --> LCD
	 LCALL TIME
	 LCALL LCD_CLEAR
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING4
	 LCALL LCD_SENDSTRING
	 MOV   R5,#03H
FAK_U1:  NOP
	 LCALL TASTATUR
	 JNC   FAK_U1
	 CJNE  R1,#FERTIG,FAK_U2   ; Abfrage Taste Fertig
	 SJMP  FAK_U3              ; Eingabe U OK
FAK_U2:  CJNE  R1,#LOESCHEN,FAK_U1 ; Abfrage Taste Loeschen
	 SJMP  FAK_U               ; Eingabe U NOT_OK
FAK_U3:  
     MOV   (10H),(46H)         ; Faktor U LSB speichern
	 MOV   (11H),(45H)         ; Faktor U MSB speichern
FAK_B:	 LCALL LCD_CLEAR
; Ausgabe LCD : Faktor B 00.00 m
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING3
	 LCALL LCD_SENDSTRING
; Eingabe Faktor B (Breite)
	 LCALL TASTEN_EINGABE
	 LCALL CONBIN             ; Faktor B --> Binaerzahl
	 MOV   (62H),(46H)        ; Faktor B LSB
	 MOV   (63H),(45H)        ; Faktor B MSB
	 LCALL LCD_CLEAR
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING3
	 LCALL LCD_SENDSTRING
	 LCALL OUT_WERT_LCD            ; Ausgabe des Faktors B
	 LCALL TIME
	 LCALL LCD_CLEAR
	 LCALL LCD_ADR1
	 MOV DPTR,#STRING5
	 LCALL LCD_SENDSTRING
FAK_B1:  NOP
	 LCALL TASTATUR
	 JNC   FAK_B1
	 CJNE  R1,#FERTIG,FAK_B2       ; Abfrage Taste Fertig
	 SJMP  FAK_MUL                 ; Eingabe B OK
FAK_B2:  CJNE  R1,#LOESCHEN,FAK_B1     ; Abfrage Taste Loeschen
	 SJMP  FAK_B                   ; Eingabe B NOT_OK
FAK_MUL: 
   MOV   (12H),(46H)             ; Faktor B LSB speichern
	 MOV   (13H),(45H)             ; Faktor B MSB speichern
; * Faktor U * 1/1 B errechnen und speichern
	 LCALL UPM_D
	 MOV   (14H),(46H)        ; Faktor U*1/1B LSB
	 MOV   (15H),(45H)        ; Faktor U*1/1B MSB
; * Faktor U * 3/4 B errechnen und speichern
	 MOV   (61H),#4BH         ; * 75
	 MOV   (60H),#00H
	 LCALL UPM_D              ; B*75/100
	 MOV   (61H),(10H)        ; Faktor U LSB
	 MOV   (60H),(11H)        ; Faktor U MSB
	 MOV   (62H),(46H)        ; Faktor B LSB 3/4
	 MOV   (63H),(45H)        ; Faktor B MSB 3/4
	 LCALL UPM_D
	 MOV   (16H),(46H)        ; Faktor U*3/4B LSB
	 MOV   (17H),(45H)        ; Faktor U*3/4B MSB
; * Faktor 1/2 B errechnen und speichern
	 MOV   (61H),#32H         ; * 50
	 MOV   (60H),#00H
	 MOV   (62H),(12H)
	 MOV   (63H),(13H)
	 LCALL UPM_D              ; B*50/100
	 MOV   (61H),(10H)        ; Faktor U LSB
	 MOV   (60H),(11H)        ; Faktor U MSB
	 MOV   (62H),(46H)        ; Faktor B LSB 1/2
	 MOV   (63H),(45H)        ; Faktor B MSB 1/2
	 LCALL UPM_D              ; Faktor U*1/2B
	 MOV   (1CH),(46H)        ; Faktor U*1/2B LSB speichern
	 MOV   (1DH),(45H)        ; Faktor U*1/2B MSB speichern
; * Faktor 1/4 B errechen und speichern
	 MOV   (61H),#19H         ; * 25
	 MOV   (60H),#00H
	 MOV   (62H),(12H)
	 MOV   (63H),(13H)
	 LCALL UPM_D              ; Faktor B*25/100
	 MOV   (61H),(10H)        ; Faktor U LSB
	 MOV   (60H),(11H)        ; Faktor U MSB
	 MOV   (62H),(46H)        ; Faktor B LSB 1/4
	 MOV   (63H),(45H)        ; Faktor B MSB 1/4
	 LCALL UPM_D              ; Faktor U*1/4B
	 MOV   (1AH),(46H)        ; Faktor U*1/4B LSB speichern
	 MOV   (1BH),(45H)        ; Faktor U*1/4B MSB speichern
	 LCALL LCD_CLEAR
	 NOP
	 NOP
NEU:     
   MOV  R0,#70H             ; Adresse laden Multiplikand MSB
	 MOV  R1,#78H             ; Adresse laden Multiplikator LSB
	 CLR  FLAN_POSI           ; Merker positive Flanke Impuls
	 CLR  A
	 MOV  R6,A
	 MOV  (25H),A
	 MOV  (26H),A
	 MOV  (27H),A
	 MOV  (28H),A
	 MOV  (29H),A
	 MOV  (70H),A
	 MOV  (71H),A
	 MOV  (72H),A
	 MOV  (73H),A
	 MOV  (74H),A
	 MOV  (75H),A
	 MOV  (76H),A
	 MOV  (77H),A
	 MOV  (78H),A
	 MOV  (79H),A
	 MOV  (7AH),A
	 MOV  (7BH),A
	 MOV  (7CH),A
	 MOV  (7DH),A
	 MOV  (7EH),A
	 MOV  (7FH),A
	 LCALL OUT_LCD            ; Ausgabe des Flaechenwertes in ha
	 MOV   R5,#03H
ANFANG:  NOP
	 LCALL TASTATUR
	 JNC   ZANF1
	 CJNE  R1,#LOESCHEN,T_ZAHL0    ; Taste Loeschen
	 SJMP  NEU
T_ZAHL0: CJNE  R1,#ZAHLEN,T_ZAHL1      ; Taste Zahlen
	 INC   R6                      ; Merker Faktor U*B
	 CJNE  R6,#04H,ZANF1
	 MOV   R6,#00H
	 SJMP  ZANF1
T_ZAHL1: CJNE  R1,#FERTIG,ZANF1
	 DEC   R6
	 CJNE  R6,#0FFH,ZANF1
	 MOV   R6,#03H
	 SJMP  ZANF1
ZANF1:   CJNE  R6,#00H,ZANF2
	 MOV   (78H),(14H)
	 MOV   (79H),(15H)
	 CLR   P1.5     ; Faktor 1/1
	 CLR   P1.6
	 CLR   P1.7
	 SJMP  ZANF0
ZANF2:   CJNE  R6,#01H,ZANF3
	 MOV   (78H),(16H)
	 MOV   (79H),(17H)
	 SETB  P1.5     ; Faktor 3/4
	 CLR   P1.6
	 CLR   P1.7
	 SJMP  ZANF0
ZANF3:   CJNE  R6,#02H,ZANF4
	 MOV   (78H),(1CH)
	 MOV   (79H),(1DH)
	 CLR   P1.5
	 SETB  P1.6    ; Faktor 1/2
	 CLR   P1.7
	 SJMP  ZANF0
ZANF4:   MOV   (78H),(1AH)
	 MOV   (79H),(1BH)
	 CLR   P1.5
	 CLR   P1.6
	 SETB  P1.7    ; Faktor 1/4
; Impulse einlesen
ZANF0: JB    FLAN_POSI,FLN      ; Abfrage: positive Flanke ?
				  ; springe wenn ja
	 MOV   A,P1               ; Port P1 --> Akku
	 ANL   A,#10H             ; Maske Bit 4 von Port P1 (P1.4)
	 JZ    ANFANG             ; Abfrage Positive Flanke
	 SETB  FLAN_POSI          ; Merker positive Flanke setzen
FLN:     MOV   A,P1               ; Port P1 --> AkKu
	 ANL   A,#10H             ; Maske Bit 4 von Port P1 (P1.4)
	 JNZ   ANFANG             ; Abfrage Negative Flanke
	 CLR   FLAN_POSI          ; Merker positive Flanke loeschen
; Impuls auswerten
	 NOP
	 MOV   R0,#70H            ; Adresse laden Multiplikand MSB
	 MOV   R1,#78H            ; Adresse laden Multiplikator LSB
	 MOV   R2,#04H            ; Anzahl
	 MOV   R3,#00H            ;
	 LCALL ADD_BIN
	 NOP
	 MOV   (43H),(70H)        ; BIN LSB
	 MOV   (42H),(71H)        ;
	 MOV   (41H),(72H)
	 MOV   (40H),(73H)        ; BIN MSB
	 LCALL CONBCD             ; Umwandlung in 5 Byte BCD-Zahl
	 NOP
	 LCALL OUT_LCD            ; Ausgabe des Flaechenwertes in ha
	 NOP
	 AJMP  ANFANG
	 NOP
	 
END

